<?php 

// Pronux MySql DB Comparer 4.2
// Copyright (c) 2010 Pronux Inc. www.pronux.ch
// Released under the GNU General Public License

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//PHP Excecution Configuration
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
error_reporting(E_ALL);
ini_set ('display_errors', true);
ini_set ('log_errors', true);
ini_set ('error_log', 'error_log');
mb_internal_encoding('UTF-8');
set_time_limit(300);
ini_set('memory_limit','1024M');

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//DB Connection
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//-------------------------------------------------------------
// OPTION 1: Use config-file from osCommerce to connect to DB  
//-------------------------------------------------------------
$osc_config_file = 'includes/configure.php';


//-------------------------------------------------------------
// OPTION 2: Use config-file from Magento to connect to DB     
//-------------------------------------------------------------
//$magento_config_file = '../app/etc/local.xml';


//-------------------------------------------------------------
// OPTION 3: Define the DB connection manual                   
//-------------------------------------------------------------
//$db_host   = 'localhost';
//$db_name 	 = 'adsf';
//$db_user 	 = 'asdf';
//$db_pw 	 = 'asdf&a';




//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//GUI Parameters
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

$showAllFieldsOnStructureCompare = false;
$useColorIfDifferentOnStructureCompare = true;

$showAllFieldsOnDataCompare = false;
$useColorIfDifferentOnDataCompare = true;

$dateFormat = 'eu';     //Date will show as: dd.mm.yyyy
//$dateFormat = 'us';   //Date will show as: mm/dd/yyyy

$showDataRowLimit = 99999999;



//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//Tables to exclude / include. By default it compares all tables in the DB
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//NOTE: If you change the following settings, you have to make new snapshots

$exclude_tables[]	= 'sessions';
$exclude_tables[]	= 'whos_online';

//$include_tables[]	= 'whos_online';
//$include_tables[]	= 'sessions';


//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//Table-Fields to exclude. By default it compares all fields of a table
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
$exclude_table_fields[]	= 'Cardinality';





