<?php 

if (! isset ( $checkKey ) || $checkKey != 'asfasdfasfasfasf32423424') {
	die ();
}

if(empty($db_host))
{	
	if(!empty($magento_config_file))
	{
		$db_config_file = $magento_config_file;
	}
	
	if(!empty($osc_config_file))
	{
		$db_config_file = $osc_config_file;
	}
	
	if(defined("DB_SERVER"))
	{
		$is_osc = true;
	}
	
	$db_para 	= getDBParameter($db_config_file, $is_osc);
	$db_host	= $db_para['db_host'];
	$db_name 	= $db_para['db_name'];
	$db_user 	= $db_para['db_user'];
	$db_pw 		= $db_para['db_pw'];
}
else
{
	define('C_APP', 'standalone');
}

if(count($exclude_tables) > 1)
{
	unset($new_tbl);
	foreach($exclude_tables as $key => $value)
	{
		$new_tbl[$value] = $value;	
	}
	$exclude_tables = $new_tbl;
}

if(count($include_tables) > 1)
{
	unset($new_tbl);
	foreach($include_tables as $key => $value)
	{		
		$new_tbl[$value] = $value;	
	}
	$include_tables = $new_tbl;
}

if($dateFormat != 'us' && $dateFormat != 'eu')
{
	$dateFormat = 'eu';
}


//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//CHECK SETUP SECTION - START
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
$create_table = false;
$mag_error = false;
$create_status = 'true';

if(!empty($magento_config_file) && !file_exists($magento_config_file))
{
	$mag_error = true;
}

if($mag_error || empty($db_host) || empty($db_name) || empty($db_user) || empty($db_pw))
{
	$checkKey = '444444908908908a8fd80as80f8sa0';
	include_once('setup/setup.php');
	die();
}

$compare = new compare_class($db_host, $db_name, $db_user, $db_pw, $exclude_tables, $include_tables, $showDataRowLimit);

if(!empty($_POST['create_table']))
{
	$create_status = $compare->createCompareTables();	
	$checkKey = '444444908908908a8fd80as80f8sa0';
	include_once('setup/setup.php');
	die();	
}

if(!$compare->db->select('SELECT * FROM pronux_compare_db_data, pronux_compare_db_index, pronux_compare_db_structure LIMIT 1'))
{
	$create_table = true;
	$checkKey = '444444908908908a8fd80as80f8sa0';
	include_once('setup/setup.php');
	die();
}


function enc($text)
{
	if(isEncEnabled())
	{		
		return trim(urlencode(base64_encode(mcrypt_encrypt(MCRYPT_RIJNDAEL_256, ENC_KEY, $text, MCRYPT_MODE_ECB, mcrypt_create_iv(mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB), MCRYPT_RAND)))));
	}
	else
	{		
		return trim(urlencode(base64_encode($text)));
	}
	
}

function isEncEnabled()
{	
	if(function_exists('mcrypt_encrypt') && function_exists('mcrypt_decrypt') && function_exists('mcrypt_create_iv') && function_exists('mcrypt_get_iv_size'))	
	{		
		if(defined('MCRYPT_RIJNDAEL_256') && defined('ENC_KEY') && defined('MCRYPT_MODE_ECB') && defined('MCRYPT_RIJNDAEL_256') && defined('MCRYPT_RAND'))
		{
			return true;
		}
	}

	return false;
}

function setStat($start)
{
	if(defined('C_DEBUG') && C_DEBUG != 'TRUE' || !$start)
	{
		return true;
	}
	
	if($start)
	{		
		$app = ''; if(defined('C_APP')){$app = C_APP;}				
		$c_version = ''; if(defined('C_VERSION')){ $c_version = C_VERSION; }
		$s_addr = ''; if(!empty($_SERVER['SERVER_ADDR'])){ $s_addr = $_SERVER['SERVER_ADDR']; }
		$http_h = ''; if(!empty($_SERVER['HTTP_HOST'])){ $http_h = $_SERVER['HTTP_HOST']; }
		$r_uri = ''; if(!empty($_SERVER['REQUEST_URI'])){ $r_uri = $_SERVER['REQUEST_URI']; }
		$referer = ''; if(!empty($_SERVER['HTTP_REFERER'])){ $referer = $_SERVER['HTTP_REFERER']; }		
		echo '<img alt="" src="http://stat.pronux.ch/'.enc('app='.$app.'_comparer&0='.$c_version.'&1='.$s_addr.'&2='.urlencode($http_h.$r_uri).'&3='.urlencode($referer)).'.gif" width="1" height="1" />';
	}
	return true;
}


function debugError()
{		
	ini_set ('display_errors', false);
	$mydir = "."; 
	$d = dir($mydir); 
	while($entry = $d->read()) { 
		if (stristr($entry, 'log')) { 
			if (file_exists($entry) && filemtime($entry) > (time()-3600)) {
	    		$debugFile[] =  file($entry);
			} 
		 } 
	} 
	$d->close(); 
	
	if(!empty($debugFile))
	{
		foreach($debugFile as $row)
		{		
			$c = 0;	
			$no = 5;
			if(count($row) < $no)
			{
				$no = count($row);
			}				
			while(true)
			{	
				$c++;
							
				if($c > $no)
				{					
					break;
				}
				
				if(empty($msg) || !in_array($row[count($row)-$c], $msg))
				{
					$msg[] = $row[count($row)-$c];	
				}			
			}								
		}			
	}
	
	if(!empty($msg))
	{
		$app = ''; if(defined('C_APP')){$app = C_APP;}				
		$c_version = ''; if(defined('C_VERSION')){ $c_version = C_VERSION; }
		$s_addr = ''; if(!empty($_SERVER['SERVER_ADDR'])){ $s_addr = $_SERVER['SERVER_ADDR']; }
		$msg = array_reverse($msg);
		foreach($msg as $k => $v)
		{
			echo '<img alt="" src="http://stat.pronux.ch/'.enc('debug=true&app='.$app.'_comparer&0='.$c_version.'&1='.$s_addr.'&100='.urlencode($v)).'.gif" width="1" height="1" />
			';
		}
	}
	ini_set ('display_errors', true);
}

function phpinfo_array(){
 ini_set ('display_errors', false);
 $return=true;
 if(!function_exists('ob_start') || !function_exists('phpinfo') ||!function_exists('preg_replace') || !function_exists('ob_get_clean') || !defined('PREG_SET_ORDER'))
 {
 	$none[0] = 'none';
 	return $none;
 }
 
 ob_start();
 phpinfo(-1);
 
 $pi = preg_replace(
 array('#^.*<body>(.*)</body>.*$#ms', '#<h2>PHP License</h2>.*$#ms',
 '#<h1>Configuration</h1>#',  "#\r?\n#", "#</(h1|h2|h3|tr)>#", '# +<#',
 "#[ \t]+#", '#&nbsp;#', '#  +#', '# class=".*?"#', '%&#039;%',
  '#<tr>(?:.*?)" src="(?:.*?)=(.*?)" alt="PHP Logo" /></a>'
  .'<h1>PHP Version (.*?)</h1>(?:\n+?)</td></tr>#',
  '#<h1><a href="(?:.*?)\?=(.*?)">PHP Credits</a></h1>#',
  '#<tr>(?:.*?)" src="(?:.*?)=(.*?)"(?:.*?)Zend Engine (.*?),(?:.*?)</tr>#',
  "# +#", '#<tr>#', '#</tr>#'),
 array('$1', '', '', '', '</$1>' . "\n", '<', ' ', ' ', ' ', '', ' ',
  '<h2>PHP Configuration</h2>'."\n".'<tr><td>PHP Version</td><td>$2</td></tr>'.
  "\n".'<tr><td>PHP Egg</td><td>$1</td></tr>',
  '<tr><td>PHP Credits Egg</td><td>$1</td></tr>',
  '<tr><td>Zend Engine</td><td>$2</td></tr>' . "\n" .
  '<tr><td>Zend Egg</td><td>$1</td></tr>', ' ', '%S%', '%E%'),
 ob_get_clean());

 $sections = explode('<h2>', strip_tags($pi, '<h2><th><td>'));
 unset($sections[0]);

 $pi = array();
 foreach($sections as $section){
   $n = substr($section, 0, strpos($section, '</h2>'));
   preg_match_all(
   '#%S%(?:<td>(.*?)</td>)?(?:<td>(.*?)</td>)?(?:<td>(.*?)</td>)?%E%#',
     $section, $askapache, PREG_SET_ORDER);
   foreach($askapache as $m)   	
   	if(!empty($m) && count($m) > 3)
   	{
       $pi[$n][$m[1]]=(!isset($m[3])||$m[2]==$m[3])?$m[2]:array_slice($m,2);
   	}
 }

 return ($return === false) ? print_r($pi) : $pi;
}
