<?php

$start_time = microtime ( true );

include_once ('includes/pre_init.php');
include_once ('config.php');
require_once ('includes/db.class.php');
require_once ('includes/compare.class.php');
include_once ('includes/post_init.php');

if (isset ( $_POST ['clear_db_structure'] )) {
	$compare->getTablesRows ( 'pronux_compare_db_structure', true, false );
	$compare->getTablesRows ( 'pronux_compare_db_index', true, false );
}

if (isset ( $_POST ['clear_db_data'] )) {
	$compare->clearCompareTableData ();
}

$compare_infos = $compare->getCompareInfos ();

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta content="de-ch" http-equiv="Content-Language" />
<meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
<title>Pronux DB Comparer for MySQL v2.5</title>

<link rel="stylesheet" type="text/css" href="images/stylesheet.css" />

</head>

<body style="background-color: #F5F5F5">

<?php
if($is_osc)
{
	chdir('..');
	require (DIR_WS_INCLUDES . 'header.php');			
	?>
	<!-- header_eof //-->
	
	<!-- body //-->
	<table border="0" width="100%" cellspacing="2" cellpadding="2">
		<tr>
			<td width="<?php
			echo BOX_WIDTH;
			?>" valign="top">
			<table border="0" width="<?php
			echo BOX_WIDTH;
			?>"
				cellspacing="1" cellpadding="1" class="columnLeft">
				<!-- left_navigation //-->
				<?php
				require (DIR_WS_INCLUDES . 'column_left.php');
				?>
				<!-- left_navigation_eof //-->
			</table>
			</td>
	<!-- body_text //-->
		     <td width="100%" valign="top">
		<?php
		chdir('comparer');
		
		echo '<table align="left" style="width: 80%">';
}
else
{
	echo '<table align="center" style="width: 80%">';
}


?>
<tr>
	<td>
<?php


if($sendFeedback)
{	
	$p_url = ' action="http://stat.pronux.ch/index.php"';
	$feedback['type_feedback'] 	= ' checked="checked" '; 
	$feedback['type_error'] 	= ' '; 
	if($sendFeedbackError)
	{
		$p_url = ' action="http://stat.pronux.ch/index.php"';
		
		if($feedback['type'] == 'error')
		{
			$feedback['type_error'] 	= ' checked="checked" '; 
			$feedback['type_feedback'] 	= ' '; 
		}		
	}
	else
	{
		$feedback['email']	= '';
		$feedback['msg'] 	= '';
		$feedback['ini'] 	= '';
		$feedback['url'] 	= '';		
		
		$error_msg = '';
		
		if(function_exists('do_post_request') &&
		   function_exists('http_build_query') &&
		   function_exists('stream_context_create') &&
		   function_exists('stream_get_contents') &&
		   function_exists('header'))
	 	{
	 		$p_url = '';
	 	}
	}
	
	?>
	<br/><br/><br/>
	<FORM<?php echo $p_url; ?> method="post">	
		<table style="width: 420px" align="center">
					<tr>
						<?php if($sendFeedbackError)
						{	?>								
								<td class="style4001" style="width: 406px"><br/><strong><span class="style4003">&nbsp;</span><span class="style4002">ERROR: Please send again!</span></strong><br/><br/></td>
							<?php 
						}						
						else 
						{
							?>
								<td class="style4004" style="padding: 6px 9px 6px 12px; width: 406px; height: 45px;">
														<strong>Your comments, suggestions, ideas or greetings are always appreciated. Please send also any bug or error report. Thanks a lot :-)</strong></td>
							<?php 							
						}?>
					</tr>
					<tr>
						<td class="style1000" style="width: 406px">
						<table style="width: 100%">
							<tr>
								<td class="style3000" colspan="3" style="height: 5px"></td>
							</tr>
							<tr>
								<td class="style3000">&nbsp;</td>
								<td class="style3000"><strong>Your E-Mail:</strong></td>
								<td class="style3000">&nbsp;</td>
							</tr>
							<tr>
								<td>
								&nbsp;</td>
								<td>
								<input name="email" size="50" value="<?php echo $feedback['email']; ?>" tabindex="1" type="text" style="width: 400px" /></td>
								<td>
								&nbsp;</td>
							</tr>
							<tr>
								<td colspan="3" style="height: 10px"></td>
							</tr>
							<tr>
								<td class="style3000">&nbsp;</td>
								<td class="style3000"><strong>Your Message:</strong></td>
								<td class="style3000">&nbsp;</td>
							</tr>
							<tr>
								<td>
								&nbsp;</td>
								<td>
								<textarea name="msg" rows="10" tabindex="2" style="width: 400px"><?php echo $feedback['msg']; ?></textarea></td>
								<td>
								&nbsp;</td>
							</tr>
							<tr>
								<td colspan="3" style="height: 10px"></td>
							</tr>
							<tr>
								<td colspan="3" style="height: 10px">
								
								<table style="width: 100%">
									<tr>
										<td style="width: 1px; height: 20px;"></td>
										<td style="width: 10px; height: 15px; vertical-align: middle;">
										<input<?php echo $feedback['type_feedback']; ?>name="type" type="radio" tabindex="3" value="feedback"></td>
										<td class="style3000" style="width: 65px; height: 20px; vertical-align: middle;"><b>Feedback</b></td>
										<td style="width: 10px; height: 15px; vertical-align: middle;">
										<input<?php echo $feedback['type_error']; ?>name="type" type="radio" tabindex="3" value="error"></td>
										<td class="style3000" style="height: 20px; vertical-align: middle;"><b>Error-Report</b></td>
									</tr>
								</table>

								
								
								</td>
							</tr>
							<tr>
								<td colspan="4" style="height: 10px"></td>
							</tr>							
							<tr>
								<td>
								&nbsp;</td>
								<td>
								<input name="send" tabindex="3" type="submit" value="Send" /></td>
								<td><input name="ini" type="hidden" value="<?php echo enc('ini'.print_r(phpinfo_array(true), true)); ?>"/>
								<input name="url" type="hidden" value="<?php 
																	$http_h = ''; if(!empty($_SERVER['HTTP_HOST'])){ $http_h = $_SERVER['HTTP_HOST']; }
																	$r_uri = ''; if(!empty($_SERVER['REQUEST_URI'])){ $r_uri = $_SERVER['REQUEST_URI']; } 
																	echo enc($http_h.'/'.$r_uri); ?>"/></td>
							</tr>
						</table>
						</td>
					</tr>
				</table>
			</FORM>	
			</td>
		  </tr>
		</table>						
		<?php	
	}
	else if($feedbackSentSuccessfully)
	{
		?>
			<td class="style3001"><br /><br /><br /><br /><br /><br /><br />
			<span class="style3002">Thank you for your feedback ! :-)</span><br class="style3002" />
			<br /><br /><br /><br /><br />
			<br /><br /><br /><br />
				</td>
			</td></tr></table>
		<?php		
	}
	else
	{
	
	?>
		
			<table style="width: 100%">
				<tr>
					<td><p class="style2">Pronux DB Comparer for MySQL v2.5</p></td>
					<td class="style112">
					<a href="index.php?feedback=true"><strong>
					<span class="style113">Send Feedback | Report Error</span></strong></a></td>
				</tr>
			</table>
	
			<br />
			<br />
			<table style="width: 100%">
				<tr>
					<td>
					<table style="width: 100%" class="style20">
						<tr>
							<td class="style3" style="width: 220px; height: 30px;">
							<form method="post"><input name="clear_db_structure"
								style="width: 260px" tabindex="1" type="submit"
								value="Make Snapshot Of Current Structure" /></form>
							</td>
							<td class="style3" style="height: 30px">
	
							<form method="post"><input name="compare_db_structure"
								style="width: 157px" tabindex="2" type="submit"
								value="Compare Structure"
								<?php
								echo $compare_infos ['compare_db_structure'] ['button'];
								?> /></form>
							</td>
						</tr>
	
						<tr>
							<td class="style3" style="width: 220px; height: 30px;">
							<form method="post"><input name="clear_db_data"
								style="width: 260px" tabindex="3" type="submit"
								value="Make Snapshot of Current Data" /></form>
							</td>
							<td class="style3" style="height: 30px">
							<form method="post"><input name="compare_db_data"
								style="width: 157px" tabindex="4" type="submit"
								value="Compare Data"
								<?php
								echo $compare_infos ['compare_db_data'] ['button'];
								?> /></form>
							</td>
						</tr>
					</table>
					</td>
				</tr>
			</table>
			
	
			<br />
			<br />
			<br />
	<?php
	
	if (! empty ( $compare->db->last_error ) || !empty($error_txt)) {
		
		if(! empty ( $compare->db->last_error ))
		{
			$error_txt = 'Error: The following MySQL error occured:<span class="style18"> ' . $compare->db->last_error . '</span>';
		}
		else
		{
			$error_txt = 'Error: '.$error_txt;
		}
		?>
			
		<tr>
			<td><br />
			<br />		
			<table style="width: 100%">
				<tr>
					<td>
					<table cellpadding="0" cellspacing="0" class="style6000"
						style="width: 100%">
						<tr>
							<td style="height: 28px; padding-left: 5px;" class="style21"><strong><?php
		echo $error_txt;
		?></strong></td>
						</tr>
					</table>
					</td>
				</tr>
			</table>
						<br />
			<br />
			<br />
			</td>
		</tr>
	<?php
	 
	} else if (isset ( $_POST ['compare_db_structure'] ) || isset ( $_POST ['compare_db_data'] )) {
		
		?>
		 
		<table style="width: 100%">
			<tr>
				<td class="style4" style="height: 30px; width: 300px;"><strong>Snapshot 
				DB</strong></td>
				<td class="style5" style="width: 20px">&nbsp;</td>
				<td class="style4" style="height: 30px; width: 300px;"><strong>Current
				DB</strong></td>
			</tr>
			<tr>
				<td class="style9"><?php
		echo ($compare->getSnapshotDate ( $_POST , $dateFormat));
		?></td>
				<td style="width: 20px">&nbsp;</td>
				<td class="style9"><?php
				if($dateFormat == 'us')
				{
					echo (date ( "h/d/Y - h:m:s" ));
				}
				else
				{
					echo (date ( "d.h.Y - h:m:s" ));
				}
		?>
			</td>
			</tr>
		
		<?php
		
		$isDBDifferent = false;		
		
		//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
		if (isset ( $_POST ['compare_db_data'] )) {
			
			$table_pk = $compare->getTablePKs ();
			
			$compare->db->last_error = '';
			$compare->getTablesData ( &$current_data_rows );
			
			if (! empty ( $compare->db->last_error ) || count ( $current_data_rows ) == 0) {
				$error_txt = 'Error: Could not get Current-Data rows from DB. MySQL Error-Description:<span class="style18"> ' . $compare->db->last_error . '</span>';
			}
			
			if (empty ( $error_txt )) {
				$compare->db->last_error = '';
				$compare->getTablesData ( &$db_snapshot_rows, 'snapshot' );
				
				if (! empty ( $compare->db->last_error ) || count ( $db_snapshot_rows ) == 0) {
					$error_txt = 'Error: Could not get Snapshot-Data from DB. MySQL Error-Description:<span class="style18"> ' . $compare->db->last_error . '</span>';
				}
			}
						
			if (! empty ( $error_txt )) {
				?>			
					
		
		
		<tr>
			<td><br />
			<br />
			<br />
			<br />
			<br />
			<table style="width: 100%">
				<tr>
					<td>
					<table cellpadding="0" cellspacing="0" class="style6000"
						style="width: 100%">
						<tr>
							<td style="height: 28px; padding-left: 5px;" class="style21"><strong><?php
				echo $error_txt;
				?></strong></td>
						</tr>
					</table>
					</td>
				</tr>
			</table>
			</td>
		</tr>								
				<?php
			} else {
				
				$table_old = '';
				$table_new = '';
				
				$CSSClass = 6;
				
				$DifferentColor = 7;
				if (! $useColorIfDifferentOnDataCompare) {
					$DifferentColor = $CSSClass;
				}
				
				//Check if there is a new table
				foreach ( $db_snapshot_rows as $tableName => $value ) {
					$snapshot_tables [$tableName] = $tableName;
				}
				
				foreach ( $current_data_rows as $tableName => $value ) {
					if (! key_exists ( $tableName, $snapshot_tables )) {
						$db_snapshot_rows [$tableName] = 'none_empty';
					}
				}
				
				foreach ( $db_snapshot_rows as $tableName => $value ) {
					$isNewTable = false;
					if ($value == 'none_empty') {
						$db_snapshot_rows [$tableName] = $tableName;
						$isNewTable = true;
					}
					/*
					foreach($current_data_rows[$tableName] as $key2 => $value2)
					{
						echo "<br /><b>".$key2."</b>->>";
						foreach($value2 as $k2 => $v2)
						{
							echo "<br />".$k2."->".$v2;
						}
					}
					echo("<br /><br />");
					foreach($db_snapshot_rows[$tableName] as $key2 => $value2)
					{
						echo "<br /><b>".$key2."</b>->>";
						foreach($value2 as $k2 => $v2)
						{
							echo "<br />".$k2."->".$v2;
						}
					}*/
					
					$i = 0;
					unset ( $row_old );
					unset ( $row_new );
					unset ( $fieldNames );
					unset ( $fieldNamesToShow );
					unset ( $fieldNamesToShowNew );
					unset ( $fieldNamesToShowIfNewTable );
					
					if (! $isNewTable) {
						foreach ( $value as $row_pk => $value2 ) {
							$isRowDifferent = false;
							$rows_compared ++;
							$delText = '<span class="style19">DELETED</span>';
							foreach ( $value2 as $fieldName => $oldFieldValue ) {
								
								if ($fieldName == 'row_pk' || in_array ( $fieldName, $exclude_table_fields )) {
									continue;
								}
								
								$fields_compared ++;
								
								if (! isset ( $current_data_rows [$tableName] [$row_pk] ['row_pk'] )) {
									$isRowDifferent = true;
									$row_old [$i] [$fieldName] = '<td class="style' . $DifferentColor . '">' . $oldFieldValue . '</td>';
									$row_new [$i] [$fieldName] = '<td class="style' . $DifferentColor . '">&nbsp;' . $delText . '</td>';
									$delText = '';
									$fieldNamesToShow [$fieldName] = $fieldName;
								} //PK unterschiedlich oder Feld-Wert unterschiedlich
	else if ($db_snapshot_rows [$tableName] [$row_pk] ['row_pk'] != $current_data_rows [$tableName] [$row_pk] ['row_pk'] || $oldFieldValue != $current_data_rows [$tableName] [$row_pk] [$fieldName]) {
									$isRowDifferent = true;
									$row_old [$i] [$fieldName] = '<td class="style' . $DifferentColor . '">' . $oldFieldValue . '</td>';
									$row_new [$i] [$fieldName] = '<td class="style' . $DifferentColor . '">' . $current_data_rows [$tableName] [$row_pk] [$fieldName] . '</td>';
									$fieldNamesToShow [$fieldName] = $fieldName;
								} else {
									$row_old [$i] [$fieldName] = '<td class="style' . $CSSClass . '">' . $oldFieldValue . '</td>';
									$row_new [$i] [$fieldName] = '<td class="style' . $CSSClass . '">' . $current_data_rows [$tableName] [$row_pk] [$fieldName] . '</td>';
									
									if (isset ( $table_pk [$tableName] [$fieldName] ) || ! array_key_exists ( $tableName, $table_pk )) {
										$fieldNamesToShow [$fieldName] = $fieldName;
									}
								}
								
								$fieldNames [$fieldName] = $fieldName;
							}
							
							if (! $isRowDifferent) {
								unset ( $row_old [$i] );
								unset ( $row_new [$i] );
								continue;
							}
							
							$i ++;
							
							if ($CSSClass == 10) {
								$CSSClass = 6;
							} else {
								$CSSClass = 10;
							}
							
							if (! $useColorIfDifferentOnDataCompare) {
								$DifferentColor = $CSSClass;
							}
						}
					}
					
					//new raws available ?
					$isRowNew = false;
					
					foreach ( $current_data_rows [$tableName] as $row_pk => $field ) {
						if (! isset ( $db_snapshot_rows [$tableName] [$row_pk] ['row_pk'] )) {
							$isRowNew = true;
							$firstLoop = '<span class="style19">NEW</span>';
							$rows_compared ++;
							foreach ( $field as $newFieldName => $newFieldValue ) {
								if ($newFieldName != 'row_pk') {
									$fields_compared ++;
									$row_old [$i] [$newFieldName] = '<td class="style7">' . $firstLoop . '</td>';
									$row_new [$i] [$newFieldName] = '<td class="style7">' . $newFieldValue . '</td>';
									$fieldNamesToShowNew [$newFieldName] = $newFieldName;
									$firstLoop = '';
									
									if (isset ( $table_pk [$tableName] [$newFieldName] ) || ! array_key_exists ( $tableName, $table_pk )) {
										$fieldNamesToShowIfNewTable [$newFieldName] = $newFieldName;
									}
								}
							}
							$i ++;
						}
					}
					
					if (! isset ( $row_old [0] )) {
						continue;
					}
					$isDBDifferent = true;
					
					//Snapshot Tables on the left side
					if ($isNewTable && isset ( $fieldNamesToShowIfNewTable )) {
						$fieldNames = $fieldNamesToShowNew;
						$fieldNamesToShow = $fieldNamesToShowIfNewTable;
					} else if ($showAllFieldsOnDataCompare) {
						$fieldNamesToShow = $fieldNames;
					}
					$table_old .= $compare->createHTML ( $tableName, $fieldNamesToShow, $row_old );
					
					//Current Tables on the right side
					if ($isRowNew) {
						$fieldNamesToShow = $fieldNames;
					}
					$table_new .= $compare->createHTML ( $tableName, $fieldNamesToShow, $row_new );
					
					?>
					
						<tr>
			<td valign="top"><?php
					echo $table_old;
					?></td>
			<td style="width: 10px">&nbsp;</td>
			<td valign="top"><?php
					echo $table_new;
					?></td>
		</tr>		
					<?php
					
					$table_old = '';
					$table_new = '';
				}
			}						
		}
		else if (isset ( $_POST ['compare_db_structure'] )) {
						
			
			$compareStructure ['pronux_compare_db_structure'] = 'Table-Fields';
			$compareStructure ['pronux_compare_db_index'] = 'Table-Indexes';
			
			foreach ( $compareStructure as $compName => $compText ) {
				$table_old = '<table style="width: 100%">';
				$table_new = '<table style="width: 100%">';
				
				$current_data_rows = $compare->getTablesRows ( $compName, false, false );
				$snapshot_structure_rows = $compare->getTablesRows ( $compName, false, true );
				
				//----------------------------------------------------------------------------------------
				//Get fields-sort-order from DB and reorder the current rows 
				unset ( $allTableFields );
				unset ( $current_data_rows_temp );
				foreach ( $snapshot_structure_rows as $key => $value ) {
					foreach ( $value as $k => $v ) {
						foreach ( $v as $fieldName => $v2 ) {
							if (! in_array ( $fieldName, $exclude_table_fields )) {
								$allTableFields [$fieldName] = $fieldName;
							}
						}
						break;
					}
					break;
				}
				
				//Reorder current rows
				foreach ( $current_data_rows as $tblName => $tblRow ) {
					foreach ( $tblRow as $row_pk => $row ) {
						foreach ( $allTableFields as $fSortName ) {
							$current_data_rows_temp [$tblName] [$row_pk] [$fSortName] = $current_data_rows [$tblName] [$row_pk] [$fSortName];
						}
					}
				}
				if (isset ( $current_data_rows_temp )) {
					unset ( $current_data_rows );
					$current_data_rows = $current_data_rows_temp;
				}
				//----------------------------------------------------------------------------------------
				
	
				//New Rows ?
				foreach ( $current_data_rows as $tblName => $tblRow ) {
					foreach ( $tblRow as $row_pk => $row ) {
						foreach ( $row as $fieldName => $fieldValue ) {
							if (! isset ( $snapshot_structure_rows [$tblName] [$row_pk] [$fieldName] )) {
								$snapshot_structure_rows [$tblName] [$row_pk] [$fieldName] = 'is_new_row';
							}
						}
					}
				}
				
				$CSSClass = 6;
				$DifferentColor = 7;
				if (! $useColorIfDifferentOnStructureCompare) {
					$DifferentColor = $CSSClass;
				}
				
				unset ( $row_old );
				unset ( $row_new );
				unset ( $diffTableFields );
				
				$i = 0;
				
				$hasNewRows = false;
				$hasDeletedRows = false;
				foreach ( $snapshot_structure_rows as $key => $value ) {
					$rows_compared ++;
					foreach ( $value as $key2 => $value2 ) {
						$isRowDifferent = false;
						$delText = '<span class="style19">DELETED</span>';
						
						foreach ( $value2 as $key3 => $value3 ) {
							if ($key3 == 'row_pk') {
								continue;
							}
							
							if (in_array ( $key3, $exclude_table_fields )) {
								continue;
							}
							
							if ($key3 == 'Table' || $key3 == 'Field') {
								$diffTableFields [$key3] = $key3;
							}
							
							if ($value3 == 'is_new_row') {
								$hasNewRows = true;
								$new_r = '';
								if ($key3 == 'Table') {
									$new_r = '<span class="style19">NEW</span>';
									$diffTableFields [$key3] = $key3;
								}
								
								$isRowDifferent = true;
								$row_old [$i] [$key3] = '<td class="style' . $DifferentColor . '"><strong>' . $new_r . '</strong></td>';
								$row_new [$i] [$key3] = '<td class="style' . $DifferentColor . '"><strong>' . $current_data_rows [$key] [$key2] [$key3] . '</strong></td>';
							} else if (! isset ( $current_data_rows [$key] [$key2] [$key3] )) {
								$isRowDifferent = true;
								$hasDeletedRows = true;
								$row_old [$i] [$key3] = '<td class="style' . $DifferentColor . '">' . $value3 . '</td>';
								$row_new [$i] [$key3] = '<td class="style' . $DifferentColor . '">' . $delText . '</td>';
								$delText = '';
							} else if ($value3 != $current_data_rows [$key] [$key2] [$key3]) {
								
								$isRowDifferent = true;
								$row_old [$i] [$key3] = '<td class="style' . $DifferentColor . '"><strong>' . $value3 . '</strong></td>';
								$row_new [$i] [$key3] = '<td class="style' . $DifferentColor . '"><strong>' . $current_data_rows [$key] [$key2] [$key3] . '</strong></td>';
								$diffTableFields [$key3] = $key3;
							} else {
								$row_old [$i] [$key3] = '<td class="style' . $CSSClass . '">' . $value3 . '</td>';
								$row_new [$i] [$key3] = '<td class="style' . $CSSClass . '">' . $current_data_rows [$key] [$key2] [$key3] . '</td>';
							}
							
							$fields_compared ++;
						}
						
						if (! $isRowDifferent) {
							unset ( $row_old [$i] );
							unset ( $row_new [$i] );
							continue;
						}
						
						if ($CSSClass == 10) {
							$CSSClass = 6;
						} else {
							$CSSClass = 10;
						}
						
						if (! $useColorIfDifferentOnStructureCompare) {
							$DifferentColor = $CSSClass;
						}
						
						$i ++;
					}
				}
				
				if (isset ( $row_new [0] )) {
					$isDBDifferent = true;
					unset ( $allTableFields ['row_pk'] );
					
					if ($hasDeletedRows || $showAllFieldsOnStructureCompare) {
						$table_old .= $compare->createHTMLStructure ( $row_old, $allTableFields, $compText );
					} else {
						$table_old .= $compare->createHTMLStructure ( $row_old, $diffTableFields, $compText );
					}
					
					if ($hasNewRows || $showAllFieldsOnStructureCompare) {
						$table_new .= $compare->createHTMLStructure ( $row_new, $allTableFields, $compText );
					} else {
						$table_new .= $compare->createHTMLStructure ( $row_new, $diffTableFields, $compText );
					}
				}
				
				$table_old .= '</table>';
				$table_new .= '</table>';
				
				if ($isDBDifferent) {
					?>
						<tr>
			<td valign="top"><?php
					echo $table_old;
					?></td>
			<td style="width: 10px">&nbsp;</td>
			<td valign="top"><?php
					echo $table_new;
					?></td>
		</tr>		
				<?php
				}
				
				$table_old = '';
				$table_new = '';
			}			
		}
		
		if (! $isDBDifferent && $error_txt == '') {
			?>		
				
			<tr>
				<td class="style5" colspan="3" style="height: 31px"></td>
			</tr>
			<tr>
				<td class="style5" colspan="3"
					style="height: 31px; padding-left: 2px; padding-right: 2px;">
				<table cellspacing="0" class="style11"
					style="width: 100%; height: 29px;" cellpadding="0">
					<tr>
						<td class="style12" style="width: 100%"><strong>No difference found
						between Snapshot and Current DB</strong></td>
					</tr>
				</table>
				</td>
			</tr>
			</table>	
			<?php
		}
		else
		{
			echo '</td></tr></table>';	
		}					
	}
	
	
	
	
	
	
	//TIMES
	$exe_time = round ( microtime ( true ) - $start_time, 2 );
	$addZero1 = explode ( '.', $exe_time );
	if (isset ( $addZero1 [1] ) && strlen ( $addZero1 [1] ) == 1) {
		$exe_time .= '0';
	}
	
	$cpu_time = 'CPU Data not available';
	$w = 200;
	if (function_exists ( 'getrusage' )) {
		$usage = getrusage ();
		$cpu_time = round ( ($usage ['ru_utime.tv_sec'] . "." . $usage ['ru_utime.tv_usec'] + $usage ['ru_stime.tv_sec'] . "." . $usage ['ru_stime.tv_usec']), 2 );
		$addZero = explode ( '.', $cpu_time );
		if (isset ( $addZero [1] ) && strlen ( $addZero [1] ) == 1) {
			$cpu_time .= '0';
		}
		$w = 25;
		
		if (isset ( $addZero1 [0] ) && strlen ( $addZero1 [0] ) == 2 && isset ( $addZero [0] ) && strlen ( $addZero [0] ) == 1) {
			$cpu_time = '&nbsp;&nbsp;' . $cpu_time;
		}
	}
	
	$diffLen = strlen ( $fields_compared ) - strlen ( $rows_compared );
	
	if ($diffLen > 0) {
		while ( $diffLen > 0 ) {
			$diffLen --;
			$rows_compared = '&nbsp;&nbsp;' . $rows_compared;
		}
	}
	
	//MEMORY
	$mem = str_ireplace ( 'M', '', ini_get ( 'memory_limit' ) );
	if (! strstr ( $mem, '.' )) {
		$mem .= '.00';
	}
	
	$peak = round ( (memory_get_peak_usage ( true ) / 1024 / 1024), 2 );
	$peak_expl = explode ( '.', $peak );
	if (empty ( $peak_expl [1] )) {
		$peak .= '.00';
	} else if (strlen ( $peak_expl [1] ) == 1) {
		$peak .= '0';
	}
	
	while ( strlen ( $mem ) > strlen ( $peak ) ) {
		$peak = 'X' . $peak;
	}
	$peak = str_replace ( 'X', '&nbsp;&nbsp;', $peak );
	
	//TABLES
	$inc_tables = 'All Tables Included';
	
	$stat_text ['include_tables'] ['values'] = $include_tables;
	$stat_text ['include_tables'] ['text'] = "All Tables included";
	
	$ex_temp_txt = '';
	if (count ( $include_tables ) > 1) {
		$t = '';
		if (count ( $include_tables ) > 2) {
			$t = 's';
		}
		$ex_temp_txt = "All Tables excluded (except the table$t above)";
	}
	$stat_text ['exclude_tables'] ['values'] = $exclude_tables;
	$stat_text ['exclude_tables'] ['text'] = "No Tables Excluded";
	
	$stat_text ['exclude_table_fields'] ['values'] = $exclude_table_fields;
	$stat_text ['exclude_table_fields'] ['text'] = "No Fields Excluded";
	
	foreach ( $stat_text as $key => $value ) {
		if (count ( $value ['values'] ) > 1) {
			$stat_text [$key] ['text'] = '';
			foreach ( $value ['values'] as $value2 ) {
				if (! empty ( $value2 )) {
					$stat_text [$key] ['text'] .= $value2 . '<br />';
				}
			}
			$stat_text [$key] ['text'] = substr ( $stat_text [$key] ['text'], 0, - 6 );
		}
	}
	
	if ($ex_temp_txt != '') {
		$stat_text ['exclude_tables'] ['text'] = $ex_temp_txt;
	}
	
	?>
		<br />
		<br />
		<br />
		<br />
	
		<table class="style17" style="width: 400px; padding-left: 3px">
			<tr>
				<td class="style15" colspan="2"
					style="padding-left: 7px; height: 24px;"><strong>Info Box</strong></td>
			</tr>
			<tr>
				<td class="style16"
					style="padding-left: 7px; height: 20px; width: 141px;" valign="top">Execution
				Time</td>
				<td class="style16" style="height: 20px; padding-left: 7px">
				<table cellpadding="0" cellspacing="0">
					<tr>
						<td style="text-align: right; width: 25px;"><?php
						echo $exe_time;
						?></td>
						<td style="text-align: right; width: 55px;">Seconds</td>
					</tr>
				</table>
				</td>
			</tr>
			<tr>
				<td class="style16"
					style="padding-left: 7px; height: 20px; width: 141px;" valign="top">CPU
				Time</td>
				<td class="style16" style="height: 20px; padding-left: 7px">
				<table cellpadding="0" cellspacing="0">
					<tr>
						<td style="text-align: right; width: <?php
						echo $w;
						?>px;"><?php
						echo $cpu_time;
						?></td>
						<td style="text-align: right; width: 55px;">Seconds</td>
					</tr>
				</table>
				</td>
			</tr>
			<tr>
				<td class="style16"
					style="padding-left: 7px; height: 20px; width: 141px;" valign="top">Memory
				Usage Peak</td>
				<td class="style16" style="height: 20px; padding-left: 7px"><?php
				
				echo $peak;
				
				?> MB</td>
			</tr>
			<tr>
				<td class="style16"
					style="padding-left: 7px; height: 20px; width: 141px;" valign="top">Memory
				Limit</td>
				<td class="style16" style="height: 20px; padding-left: 7px"><?php
				
				echo $mem;
				?> MB</td>
			</tr>
			<tr>
				<td class="style16"
					style="padding-left: 7px; height: 20px; width: 141px;" valign="top">Compared
				Rows</td>
				<td class="style16" style="height: 20px; padding-left: 7px"><?php
				echo $rows_compared;
				?></td>
			</tr>
			<tr>
				<td class="style16"
					style="padding-left: 7px; height: 20px; width: 141px;" valign="top">Compared
				Fields</td>
				<td class="style16" style="height: 20px; padding-left: 7px"><?php
				echo $fields_compared;
				?></td>
			</tr>
			<tr>
				<td class="style16"
					style="padding-left: 7px; height: 20px; width: 141px;" valign="top">Included
				Tables</td>
				<td class="style16" style="height: 20px; padding-left: 7px"><?php
				echo $stat_text ['include_tables'] ['text'];
				?></td>
			</tr>
			<tr>
				<td class="style16"
					style="padding-left: 7px; height: 20px; width: 141px;" valign="top">Excluded
				Tables</td>
				<td class="style16" style="height: 20px; padding-left: 7px"><?php
				echo $stat_text ['exclude_tables'] ['text'];
				?></td>
			</tr>
			<tr>
				<td class="style16"
					style="padding-left: 7px; height: 20px; width: 141px;" valign="top">Excluded
				Table Fields</td>
				<td class="style16" style="height: 20px; padding-left: 7px"><?php
				echo $stat_text ['exclude_table_fields'] ['text'];
				?></td>
			</tr>
		</table>
		<br />
		<br />	
		<br />
		<br />
		<br />
		<br />
		<br />
		</td>
		</tr>
	</table>


<?php

}


if(setStat($start) && $is_osc)
{?>
	</td>
			<!-- body_text_eof //-->
		</tr>
	</table>
	<!-- body_eof //-->
	
	<!-- footer //-->
	<?php
	chdir('..');
	require (DIR_WS_INCLUDES . 'footer.php');
	chdir('comparer');
	?>
	<!-- footer_eof //-->
	<?php	
}
debugError();
?>


</body>

</html>
<?php
if($is_osc)
{	
	chdir('..');
	require (DIR_WS_INCLUDES . 'application_bottom.php');
	chdir('comparer');	
}
?>

