<?php

if (! isset ( $checkKey ) || $checkKey != '444444908908908a8fd80as80f8sa0') {
	die ();
}

$setup1StatusText	= 'Setup Step 1: DB-Connection';
$setup1Status 		= 'Open config.php and define your DB-Connection';
$setup1ButtonText 	= 'Check DB Connection';
$setup1ButtonValue 	= 'check_db';
$setup1StatusRecheck = '<br><br><span class="style7">Please re-check config.php!<span><br><br>';
		

if($create_table)
{
	$setup1StatusText	= 'Setup Step 2: Create Tables';
	$setup1Status 		= "Please click the button below to create the required snapshot tables.";
	$setup1ButtonText 	= 'Create Tables';
	$setup1ButtonValue 	= 'create_table';					
}
else if($create_status != 'true')
{
	if($create_status == 'created')
	{
		$setup1StatusText	= 'Setup Step 2: Create Tables';
		$setup1Status 		= 'Tables were created successfully. Setup complete.';
		$setup1ButtonText 	= 'Go to Startpage';
		$setup1ButtonValue 	= 'none';	
		
		
		//delete sql file
		error_reporting(0);
		ini_set ('display_errors', false);
		$mydir = "setup"; 
		$d = dir($mydir); 
		while($entry = $d->read()) { 
			 if ($entry!= "." && $entry!= "..") { 
			 	unlink($mydir."/".$entry); 
			 } 
		} 
		$d->close(); 
		rmdir($mydir);	
		

		//create menu
		$fname 		= '../includes/boxes/tools.php';
		if(file_exists($fname))
		{
			$handle	 	= fopen($fname, 'r');
			if($handle)
			{
				$contents 	= fread($handle, filesize($fname));
				if(fclose($handle))
				{
					$handle	= fopen($fname, 'w');
									
					if(isset($handle) && $handle && isset($contents) && trim($contents) != '')
					{
						$contents2 = str_replace("array('text'  => '<a", "array('text'  => '<a href=\"' . tep_href_link(\"comparer/index.php\") . '\" class=\"menuBoxContentLink\">DB Comparer</a><br>' . \n                                   '<a", $contents);
						
						if($contents != $contents2 && !stristr($contents, "DB Comparer"))
						{
							fwrite($handle, $contents2, strlen($contents2));
						}
						else
						{		
							fwrite($handle, $contents, strlen($contents));						
						}
						fclose($handle);
					}					
				}
			}
			fclose($handle);
		}		

		error_reporting (E_ALL);
		ini_set ('display_errors', true);
	}
	else
	{
		$setup1StatusText	= 'Setup Step 2: Create Tables';
		$setup1Status 		= "Could not create Tables. Following Error occured: ".$create_status;
		$setup1ButtonText 	= 'Create Tables';
		$setup1ButtonValue 	= 'create_table';	
	}	
}




?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta content="de-ch" http-equiv="Content-Language" />
<meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
<title>Pronux MySQL Comparer 4.2</title>
<style type="text/css">
.style1 {
	border-left: 1px solid #000000;
	border-right: 1px solid #000000;
	border-top: 1px solid #000000;
	background-color: #E5E5E5;
	margin-left: 7px;
	padding-left: 7px;
	font-family: Arial, Helvetica, sans-serif;
	font-size: 13px;
	border-bottom-style: none;
	border-bottom-color: #000000;
	text-align: left;
	color: #333333;
}

.style2 {
	border: 1px solid #000000;
	background-color: #D3DCE3;
	padding-left: 7px;
	text-align: left;
	font-family: Verdana, Geneva, Tahoma, sans-serif;
	font-size: 12px;
}

.style4 {
	border-top-width: 0px;
}

.style6 {
	border-left: 1px solid #000000;
	border-right: 1px solid #000000;
	border-top: 0px solid #000000;
	border-bottom: 1px solid #000000;
	text-align: right;
	background-color: #D3DCE3;
	padding-right: 8px;
}
.style7 {
	color: #FF0000;
	font-weight: bold;
}

</style>
</head>

<body>

<p>


<form action="index.php" method="post">

<table align="center" style="width: 100%">
	<tr>
		<td><br />
		<br />
		<br />
		<br />
		<br />
		<br />
		<br />
		<table align="center" cellpadding="0" cellspacing="0" class="style4">
			<tr>
				<td class="style1" style="height: 30px"><strong><?php echo $setup1StatusText; ?></strong></td>
			</tr>
			<tr>
				<td class="style2" style="height: 100px; width: 400px;"><?php
		
				if($mag_error)
				{
					$setup1Status 	= "The Magento config file <b>'$magento_config_file'</b> could not be found.";
					$setup1Status 	.= $setup1StatusRecheck;
				}
				else if($create_table)
				{
					//do nothing
				}
				else if(isset($_POST ['check_db']))
				{
					if(empty($db_host) || empty($db_name) || empty($db_user) || empty($db_pw))
					{
						if (empty($db_host))
						{
							$setup1StatusTemp = 'DB-Hostname';
						}
						else if(empty($db_name))
						{
							$setup1StatusTemp = 'DB-Name';
						}
						else if(empty($db_user))
						{
							$setup1StatusTemp = 'DB-User';
						}
						else if(empty($db_pw))
						{
							$setup1StatusTemp = 'DB-Password';
						}
						
						$setup1Status = "Error: $setup1StatusTemp not defined!";
						$setup1Status .= $setup1StatusRecheck;
					}
					else
					{				
						$db = new db_class();
						if (!$db->connect($db_host, $db_user, $db_pw, $db_name, true))
						{
							$setup1Status = $db->print_last_error(false);
							$setup1Status .= $setup1StatusRecheck;				
						}
						else
						{
							$setup1Status = 'Status: DB-Connection OK';
							$setup1ButtonText 	= 'Next Step';
							$setup1ButtonValue 	= 'create_table';
						}
					}
				}

				echo $setup1Status;
				
				?></td>
			</tr>
			<tr>
				<td class="style6" style="height: 30px;"><input name="<?php echo($setup1ButtonValue); ?>"
					type="submit" value="<?php echo($setup1ButtonText); ?>" style="width: 152px"
					tabindex="1" /></td>
			</tr>
		</table>
		<br />
		<br />
		<br />
		<br />
		<br />
		<br />
		<br />
		<br />
		<br />
		<br />
		<br />
		<br />
		<br />
		<br />
		</td>
	</tr></table>
</form>
<br />
</p>

</body>

</html>