<?php 

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//Check all Parameters for GET / POST -> Security
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

$error_txt = '';

//check if osc
$is_osc = false;
if(file_exists('../includes/application_top.php') && function_exists("chdir"))
{	
	if(chdir('..'))
	{
		$selected_box = 'tools';
		$_GET['selected_box'] = 'tools';		
		require ('includes/application_top.php');		
		if(chdir('comparer'))
		{
			$is_osc = true;
		}
	}		
}

if(isset($_SERVER['REQUEST_URI']) && substr($_SERVER['REQUEST_URI'], -9) != 'index.php' && substr($_SERVER['REQUEST_URI'], -23, -4) != 'index.php?feedback=')
{	
	header("Location: index.php");
	die();
}

$para['compare_db_structure'] 	= 'compare_db_structure';
$para['compare_db_index']		= 'compare_db_index';
$para['compare_db_data'] 		= 'compare_db_data';
$para['clear_db_structure'] 	= 'clear_db_structure';
$para['clear_db_data'] 			= 'clear_db_data';
$para['check_db'] 				= 'check_db';
$para['create_table'] 			= 'create_table';

if(!empty($_POST['email']))
{
	$feedback['email']	= $_POST['email'];
	$feedback['msg'] 	= $_POST['msg'];
	$feedback['type'] 	= $_POST['type']; 
	$feedback['ini'] 	= $_POST['ini'];
	$feedback['url'] 	= $_POST['url'];	
}	

foreach($_POST as $key => $value)
{	
	if(!in_array($key, $para) || $key != stripslashes($key) || $value != stripslashes($value))
	{		
		unset($_POST[$key]);
		continue;	
	}		
	$_POST[$key] = $para[$key];		
}


$sendFeedback = false;
$sendFeedbackError = false;
$feedbackSentSuccessfully = false;

if(!empty($feedback))
{	
	if(do_post_request($feedback))
	{
		$feedbackSentSuccessfully = true;
	}
	else
	{
		logError("Could not send Feedback via fopen");
		$sendFeedbackError = true;
		$sendFeedback = true;
	}		
}
else
{
	if(!empty($_GET['feedback']))
	{
		if($_GET['feedback'] == 'done')
		{
			$feedbackSentSuccessfully = true;
		}
		else
		{
			$sendFeedback = true;
		}
	}
}

$_GET = array();

$start = false;
if(count($_POST) == 0)
{
	$start = true;
}

if(function_exists('md5_file'))
{
	//die(md5_file("index.php"));
	
	if(	md5_file("index.php") 					!= '50ba3ece8b9f1598246e3506ff8e99ab' || 
		md5_file("includes/post_init.php") 		!= '965807711a6b9ea76fa193b3af9512fc' || 
	 	md5_file("includes/db.class.php") 		!= 'a372b85cdbfdcee41d4d7c268ab91bd1' || 
	 	md5_file("includes/index.html") 		!= 'cc4b45b32556872b2babadfc0ba3b47b' ||
	   	md5_file("includes/compare.class.php") 	!= '8e985deac5f54133b1663866b0e05c73')
	   	{
	   		$error_txt = "Possible file corruption detected. Please reinstall this application.";
	   	}
	   	 
}




//todo -> check requirements before install
if (function_exists ( "mb_substr()" )) {
	die ( "<br /><br /><br /><br />ERROR: To use this tool you need to enable mbstring in your PHP configuration -> google it" );
}

$checkKey = 'asfasdfasfasfasf32423424';


//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//Predefined variables
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
$magento_config_file 		= '';
$exclude_tables[]			= 'pronux_compare_db_data';
$exclude_tables[] 			= 'pronux_compare_db_structure';
$exclude_tables[] 			= 'pronux_compare_db_index';
$include_tables[0]			= '';
$exclude_table_fields[0]	= '';
$rows_compared				= 0;
$fields_compared			= 0;
define('C_DEBUG', 'TRUE');
define('ENC_KEY', '12aqweroiuer843lj89fdsjbsd1f5');
define('C_VERSION', '1');

$_POST['selected_box']	= 'tools';
$_GET['selected_box']	= 'tools';



//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//Some Functions
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
function getDBParameter($config_file = '', $is_osc = false)
{
	if($is_osc || stristr($config_file, "configure.php"))
	{
		define('C_APP', 'osc');
		if(!$is_osc)
		{
			if(file_exists('../includes/configure.php'))
			{
				$config_file = '../includes/configure.php';
			}
			else if(!file_exists($config_file))
			{
				$config_file = '../'.$config_file;
				if(!file_exists($config_file))
				{
					$config_file = '/admin/includes/configure.php';
				}
			}
			include($config_file);			
		}
		return get_osc_parameter();
	}
	
	define('C_APP', 'magento');
	return get_magento_parameter($config_file);	
}

function get_osc_parameter()
{
	$db_para['db_host']	= constant("DB_SERVER");
	$db_para['db_name'] = constant("DB_DATABASE");
	$db_para['db_user'] = constant("DB_SERVER_USERNAME");
	$db_para['db_pw'] 	= constant("DB_SERVER_PASSWORD");

	return $db_para;
}

function get_magento_parameter($magento_config_file)
{	
	if(!file_exists($magento_config_file))
	{
		$db_parameter['db_host'] = 'error';
		$db_parameter['db_user'] = 'error';
		$db_parameter['db_pw']   = 'error';
		$db_parameter['db_name'] = 'error';
		return $db_parameter;
	}
	
	$handle 		= fopen($magento_config_file, "r");
	$config_string 	= fread($handle, filesize($magento_config_file));
	
	$db_parameter['db_host'] 	= get_magento_config($config_string, 'host');
	$db_parameter['db_user'] 	= get_magento_config($config_string, 'username');
	$db_parameter['db_pw'] 		= get_magento_config($config_string, 'password');
	$db_parameter['db_name'] 	= get_magento_config($config_string, 'dbname');

	return $db_parameter;
}

function get_magento_config($connection_string, $config_value)
{	
	$str1 = substr($connection_string, strpos($connection_string, '<'.$config_value.'><![') + 11 + strlen($config_value));
	return substr($str1, 0, strpos($str1, ']]></'.$config_value.'>'));
}

function do_post_request($data)
{			
	 ini_set ('display_errors', false);	 
	 $data['fopen'] = 'true';
	 $data = http_build_query($data);
	 	 	 	
     $params = array('http' => array(
                  	'method' => 'POST',
      				'content-type' => 'text/html',
                  	'charset' => 'UTF-8',     
                  	'content' => $data));
               
 	 $optional_headers = header("Content-type: text/html; charset=utf-8");
     
     $ctx = stream_context_create($params);
     $fp = @fopen('http://stat.pronux.ch/index.php', 'rb', false, $ctx);
     if (!$fp) {
        return false;
     }
          
     if(@stream_get_contents($fp) == 'okey')
     {
        ini_set ('display_errors', true);  
     	return true;
     }
     
     ini_set ('display_errors', true);  
     return false;      
    
}

function logError($txt)
{
	ini_set ('display_errors', false);
	if(!empty($txt))
	{
		$filename = 'error_comparer.log';
		$fp = @fopen($filename,"a");
		if($fp)
		{
			$logs = date("d.m.Y | H:i:s").": ".$txt."\n";
			@fputs($fp, $logs);
		}		
		fclose($fp);
	}
	ini_set ('display_errors', true);
}

