SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";
DROP TABLE IF EXISTS `pronux_compare_db_data`;
CREATE TABLE IF NOT EXISTS `pronux_compare_db_data` (
  `compare_db_data_id` int(11) NOT NULL auto_increment,
  `table` varchar(400) collate utf8_general_ci NOT NULL,
  `field` varchar(400) collate utf8_general_ci NOT NULL,
  `value` text collate utf8_general_ci NOT NULL,
  `row_pk` text collate utf8_general_ci NOT NULL,
  `date_modified` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`compare_db_data_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci AUTO_INCREMENT=1;


DROP TABLE IF EXISTS `pronux_compare_db_index`;
CREATE TABLE IF NOT EXISTS `pronux_compare_db_index` (
  `compare_db_index_id` int(11) NOT NULL auto_increment,
  `Table` varchar(400) collate utf8_general_ci NOT NULL,
  `Non_unique` int(11) NOT NULL,
  `Key_name` varchar(400) collate utf8_general_ci NOT NULL,
  `Seq_in_index` int(11) NOT NULL,
  `Column_name` varchar(400) collate utf8_general_ci NOT NULL,
  `Collation` varchar(400) collate utf8_general_ci NOT NULL,
  `Cardinality` varchar(400) collate utf8_general_ci NOT NULL,
  `Sub_part` varchar(400) collate utf8_general_ci NOT NULL,
  `Packed` varchar(400) collate utf8_general_ci NOT NULL,
  `Null` varchar(400) collate utf8_general_ci NOT NULL,
  `Index_type` varchar(400) collate utf8_general_ci NOT NULL,
  `Comment` text collate utf8_general_ci NOT NULL,
  `date_modified` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`compare_db_index_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci AUTO_INCREMENT=1;


DROP TABLE IF EXISTS `pronux_compare_db_structure`;
CREATE TABLE IF NOT EXISTS `pronux_compare_db_structure` (
  `compare_db_structure_id` int(11) NOT NULL auto_increment,
  `Table` varchar(400) collate utf8_general_ci NOT NULL,
  `Field` varchar(400) collate utf8_general_ci NOT NULL,
  `Type` varchar(400) collate utf8_general_ci NOT NULL,
  `Collation` varchar(400) collate utf8_general_ci NOT NULL,
  `Null` varchar(400) collate utf8_general_ci NOT NULL,
  `Key` varchar(400) collate utf8_general_ci NOT NULL,
  `Default` varchar(400) collate utf8_general_ci NOT NULL,
  `Extra` varchar(400) collate utf8_general_ci NOT NULL,
  `Privileges` varchar(400) collate utf8_general_ci NOT NULL,
  `Comment` varchar(400) collate utf8_general_ci NOT NULL,
  `date_modified` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`compare_db_structure_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci AUTO_INCREMENT=1;